Attribute VB_Name = "basAllg"
Option Explicit

Global Const strcAppName = "OTax"

Global RAS_NT4PerfIsInitialized As Boolean

Declare Function GetNTRASBytesTotal Lib "NT4RAS.DLL" Alias "_GetNTRASBytesTotal@0" () As Long

Type OSVERSIONINFO
  dwOSVersionInfoSize As Long
  dwMajorVersion As Long
  dwMinorVersion As Long
  dwBuildNumber As Long
  dwPlatformId As Long
  szCSDVersion As String * 128      '  Maintenance string for PSS usage
End Type
Public Const VER_PLATFORM_WIN32s = 0
Public Const VER_PLATFORM_WIN32_WINDOWS = 1
Public Const VER_PLATFORM_WIN32_NT = 2
Declare Function GetVersionEx Lib "kernel32" Alias "GetVersionExA" (lpVersionInformation As OSVERSIONINFO) As Long

Global OS As Long

Global Const OS_WIN95 = &H40
Global Const OS_WIN98 = &H41

Global Const OS_WINNT4 = &H140
Global Const OS_WINNT5 = &H151

Global Const OS_WINNEWSFGW = &H1

Global eng As Boolean
Global FromIDE As Boolean

Global lngCH As Long

Global lastScrnW As Long
Global lastScrnH As Long
Global lngPLeft As Long, lngPRight As Long, lngPTop As Long, lngPWidth As Long
Global lngVorlauf As Long

Global blnHangupSnd As Boolean
Global blnWarnSnd As Boolean
Global lTrafficCount As Long
Global lngLastTraffic As Long
Global lngLast2Traffic As Long
Global lngLowTraffic As Long
Global blnLowTrafHangup As Boolean
Global lngAutoHangupTakte As Long
Global strAutoHangupTakte As String
Global blnShowSpeed As Boolean
Global blnShowOnlineTime As Boolean
Global blnShowRest As Boolean
Global blnHideRest As Boolean



Global strConn(0 To 29) As String
Global strTime(0 To 29, 0 To 7) As String
Global strTakt(0 To 29, 0 To 7) As String

Global datStartTime As Date


Global strConnecting As String
Global strChkPW As String
Global strPWFailed As String
Global strFailed As String
Global strConnected As String
Global strDisconnecting As String
Global strDisconnected As String



Declare Function GetSystemDefaultLangID Lib "kernel32" () As Integer

Declare Function ShowWindow Lib "user32" (ByVal hwnd As Long, ByVal nCmdShow As Long) As Long
Public Const SW_RESTORE = 9
Declare Function IsIconic Lib "user32" (ByVal hwnd As Long) As Long


Declare Function SetWindowPos Lib "user32" (ByVal hwnd As Long, ByVal hWndInsertAfter As Long, ByVal x As Long, ByVal Y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long) As Long
Global Const HWND_TOP = 0
Global Const HWND_TOPMOST = -1
Global Const HWND_NOTOPMOST = -2
Global Const SWP_NOMOVE = &H2
Global Const SWP_NOSIZE = &H1
Global Const SWP_NOACTIVATE = &H10
Global Const SWP_SHOWWINDOW = &H40

Declare Function GetAsyncKeyState Lib "user32" (ByVal vKey As Long) As Integer
Global Const on_tab = 1
Global Const on_alt = 2
Global Const on_mouse = 3
Global Const on_else = 4

Declare Function GetForegroundWindow Lib "user32" () As Long
Declare Function SetForegroundWindow Lib "user32" (ByVal hwnd As Long) As Long
Declare Function GetActiveWindow Lib "user32" () As Long
Declare Function SetActiveWindow Lib "user32" (ByVal hwnd As Long) As Long

Declare Function PlaySound Lib "winmm.dll" Alias "PlaySoundA" (ByVal lpszName As String, ByVal hModule As Any, ByVal dwFlags As Long) As Long
Public Const SND_NOWAIT = &H2000      '  don't wait if the driver is busy
Public Const SND_ASYNC = &H1


Declare Function RegOpenKeyEx Lib "advapi32.dll" Alias "RegOpenKeyExA" (ByVal hKey As Long, ByVal lpSubKey As String, ByVal ulOptions As Long, ByVal samDesired As Long, phkResult As Long) As Long
Declare Function RegQueryValueEx Lib "advapi32.dll" Alias "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, lpType As Long, lpData As Any, lpcbData As Long) As Long
Declare Function RegCloseKey Lib "advapi32.dll" (ByVal hKey As Long) As Long




Public Const WS_DXFULLSCREEN2 = &H94000000
Function FindBBarWindow() As Long

  Dim h As Long
  
  h = FindWindow("ThunderRT5Form", "BBar")
  If h = 0 Then
    h = FindWindow("ThunderRT6FormDC", "BBar")
  End If
  If h = 0 Then
    h = FindWindow("ThunderForm", "BBar")  'IDE
  End If
  
  FindBBarWindow = h

End Function

Function getTraffic() As Long


Select Case OS
Case OS_WINNT4
  On Error Resume Next
    getTraffic = GetNTRASBytesTotal()  'getNT4RASTraffic()
  On Error GoTo 0
Case Is >= OS_WINNT5
  getTraffic = GetNT5RASBytesTotal(lngCH)
Case OS_WIN95, OS_WIN98
  getTraffic = GetWin9xBytesTotal()
End Select

End Function

'trimmt auch vbNullChar weg, was das normale Trim nicht tut
'der String wird vor dem ersten NULL abgeschnitten
'
Function nTrim$(ByVal s As String)
  
  Dim l As Long, i As Long
    
  s = Trim$(s)
  
  If Len(s) > 0 Then
    i = InStr(s, vbNullChar)
    If i > 0 Then
      s = Left$(s, i - 1)
    End If
  End If
  
  nTrim$ = s

raus:

End Function




Function getStrWindowText(h As Long) As String

  Dim s As String
  Dim l As Long
  
  l = GetWindowTextLength(h)
  s = Space$(l + 1)
  Call GetWindowText(h, s, l + 1)
  
  getStrWindowText = Trim$(s)

  #If debView = 1 Then
    Call OutDebStr(getStrWindowText)
  #End If

raus:

End Function


Sub readSettings()

Dim s As String
Dim c As Long, l As Long, co As Long

Dim p As Long
Dim s2 As String

Const sSet As String = "Settings"

c = 0
Do
  s = GetSetting(strcAppName, sSet, Format$(c, "00"), "")
  p = 0
  s2 = ParseString(p, s, ",")
  
  co = 0
  Do Until s2 = strConn(co) Or strConn(co) = ""
    co = co + 1
  Loop
  
  If strConn(co) <> "" Then
    For l = 0 To 3
      strTime(co, l) = ParseString(p, s, ",")
    Next l
    For l = 0 To 3
      strTakt(co, l) = ParseString(p, s, ",")
    Next l
    For l = 4 To 7
      strTime(co, l) = ParseString(p, s, ",")
    Next l
    For l = 4 To 7
      strTakt(co, l) = ParseString(p, s, ",")
    Next l
  
  End If
  c = c + 1
Loop Until s = "" Or s = ",,,,,,,,,"


s = GetSetting(strcAppName, sSet, "Right", "")
If IsNumeric(s) Then
  lngPRight = Val(s)
  lngPLeft = Screen.Width - Val(s) - frmProgress.Width
Else
  s = GetSetting(strcAppName, sSet, "Left", "")
  If IsNumeric(s) Then
    lngPLeft = Val(s)
    lngPRight = Screen.Width - frmProgress.Width - lngPLeft
  Else
    'kein Wert vorgegeben - vielleicht knnen wir bei BBar andocken...
    Dim h As Long
    h = FindBBarWindow()
    If h <> 0 Then
      Dim r As RECT
      Call GetWindowRect(h, r)
      lngPRight = Screen.Width - r.Right * Screen.TwipsPerPixelX
      lngPLeft = Screen.Width - lngPRight - frmProgress.Width
      lngPTop = r.bottom * Screen.TwipsPerPixelY
    End If
  End If
End If

If lngPTop = 0 Then
  s = GetSetting(strcAppName, sSet, "Top", "")
  If IsNumeric(s) Then
    lngPTop = Val(s)
  End If
End If

If lngPLeft <= 0 Or lngPTop <= 0 Or lngPLeft > Screen.Width Or lngPTop > Screen.Height Then
  lngPLeft = Screen.Width - 3050
  lngPTop = 15 * 17
End If

s = GetSetting(strcAppName, sSet, "HangupSnd", "0")
If s = "0" Then
  blnHangupSnd = False
Else
  blnHangupSnd = True
End If
s = GetSetting(strcAppName, sSet, "WarnSnd", "0")
If s = "0" Then
  blnWarnSnd = False
Else
  blnWarnSnd = True
End If

s = GetSetting(strcAppName, sSet, "AutoHangup", "0")
If s = "0" Then
  blnLowTrafHangup = False
Else
  blnLowTrafHangup = True
End If


s = GetSetting(strcAppName, sSet, "Vorlauf", "2")
lngVorlauf = Val(s)


s = GetSetting(strcAppName, sSet, "HangupBytes", "512")
lngLowTraffic = Val(s)

Call SaveSetting(strcAppName, sSet, "HangupBytes", s)

s = GetSetting(strcAppName, sSet, "HangupTakte", "1")
lngAutoHangupTakte = Val(s)
Call bringInRange(lngAutoHangupTakte, 1, 10)

s = GetSetting(strcAppName, sSet, "ShowSpeed", "1")
blnShowSpeed = (s <> 0)

s = GetSetting(strcAppName, sSet, "ShowOnlineTime", "1")
blnShowOnlineTime = (s <> 0)

s = GetSetting(strcAppName, sSet, "ShowRest", "1")
blnShowRest = (s <> 0)





End Sub


Function getOS() As Long
  
  Dim OS As win.OSVERSIONINFO
  
  OS.dwOSVersionInfoSize = 148
  Call win.GetVersionEx(OS)
  
  
  Select Case OS.dwPlatformId
  
  Case VER_PLATFORM_WIN32_WINDOWS
    If OS.dwMinorVersion = 0 Then
      getOS = OS_WIN95  ' 0
    Else
      getOS = OS_WIN98  ' 10h
    End If
  
  Case VER_PLATFORM_WIN32_NT
    If OS.dwMajorVersion = 4 Then
      getOS = OS_WINNT4
    Else
      getOS = OS_WINNT5
    End If
  
  End Select
  
raus:

End Function



Public Function getDynRegBinAsLong(keyName As String, keyValue As String) As Long

Dim phkResult As Long
Dim lplen As Long
Dim temp As Long
Dim l As Long, v As Long
Dim buffer() As Byte

ReDim buffer(4)
lplen = 4


'temp = RegOpenKeyEx(HKEY_DYN_DATA, keyName, 0, 983103, phkResult)
temp = RegOpenKeyEx(&H80000006, keyName, 0, 983103, phkResult)
temp = RegQueryValueEx(phkResult, keyValue, 0, 3, buffer(0), lplen)
temp = RegCloseKey(phkResult)

getDynRegBinAsLong = buffer(0) + 256 * CLng(buffer(1)) + 65536 * CLng(buffer(2)) + 16777216 * CLng(buffer(3))

End Function

Function GetWin9xBytesTotal() As Long

Dim hKey As Long, strKey As String, strSubKey As String, strV As String
Dim recvd As Long, xmit As Long

strKey = "PerfStats\StatData"
strSubKey = "Dial-Up Adapter\TotalBytesXmit"
xmit = getDynRegBinAsLong(strKey, strSubKey)
strSubKey = "Dial-Up Adapter\BytesRecvd"
recvd = getDynRegBinAsLong(strKey, strSubKey)

GetWin9xBytesTotal = xmit + recvd

End Function

'gibt Auskunft, wie ein Control den Fokus erhalten hat
'so kann man z.B. Textboxen das unter Windows bliche
'Verhalten beibringen
'(us)
Function GotFocusOn()
  
  Const Key_Tab = &H9
  Const Key_Menu = &H12
  Const Key_lButton = &H1
  
  
  If GetAsyncKeyState(Key_Tab) = &H8001 Then
    GotFocusOn = on_tab
  ElseIf GetAsyncKeyState(Key_Menu) = &H8001 Then
    GotFocusOn = on_alt
  ElseIf GetAsyncKeyState(Key_lButton) = &H8001 Then
    GotFocusOn = on_mouse
  Else
    GotFocusOn = on_else
  End If

End Function






Function isWeekend() As Boolean


Dim d As Date
Dim w As Long
Dim f As Variant
Dim l As Long

'f = Array("1.1.", "1.5.", "24.12.", "25.12.", "26.12.", "31.12.")

d = Date

w = WeekDay(d, 1)

If w = 1 Or w = 7 Then
  isWeekend = True
  Exit Function
End If

'For l = 0 To UBound(f)
'  If d = CDate(f(l)) Then
'    isWeekend = True
'    Exit Function
'  End If
'Next l

isWeekend = False

End Function

Sub Main()

  
  If App.PrevInstance Then
    End
  End If
  
  OS = getOS()
  
  On Error Resume Next
    Debug.Print (1 / 0);
    If Err <> 0 Then
      FromIDE = True
    Else
      FromIDE = False
    End If
  On Error GoTo 0
  
  
  Call Load(frmMain)
  
  frmMain.Visible = False
  
  
  'HangupTakte = Array(1, 2, 3, 4, 5, 10, 20, 30)
  

End Sub

Function frac(ByVal dblWork As Double) As Double

frac = dblWork - Int(dblWork)

End Function

Sub ShowProgress()

  Dim h As Long
  
  h = GetForegroundWindow()
  
  
  Call Unload(frmSettings) 'hart aber ntig
  
  Call Load(frmProgress)
  Call frmProgress.Move(-1111, -1111)
  'Call frmProgress.Show
  
  Call ShowWindow(frmProgress.hwnd, SW_SHOWNOACTIVATE)
  
  Call SetForegroundWindow(h)
  Call SetWinOnTopNow(frmProgress.hwnd)
  Call frmProgress.SetOption
  
  lngPLeft = Screen.Width - lngPRight - frmProgress.Width
  Call frmProgress.Move(lngPLeft, lngPTop)

End Sub

Sub TopMostDo0(h As Long)

Call SetWindowPos(h, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE + SWP_NOSIZE + SWP_NOACTIVATE)

End Sub


Sub SetWinOnTopNow(h As Long)

  Dim f As Long, l As Long
  
  f = GetForegroundWindow()
  l = GetWindowLong(f, GWL_STYLE)
  
  'Debug.Print "Top:", getStrWindowTextAndClass(f), Hex(l)
  
  If IsDXWindow(f) Then
    Call SetWindowZOrder(h, HWND_BOTTOM)
  Else
    Dim wp As Long
    Dim p As POINTL
    
    Call GetCursorPos(p)
    wp = WindowFromPoint(p.x, p.Y)
    'Debug.Print getStrWindowTextAndClass(wp), IsSpecialWindow(wp), wp = frmButtons.hWnd
    If (Not IsPopupActive() And Not IsSpecialWindow(wp)) Or wp = h Then
      Dim hBB As Long
      hBB = FindBBarWindow()
      If hBB <> 0 Then
        Call SetWindowZOrder(h, hBB)
        'Debug.Print "BB"
      Else
        Call SetWindowZOrder(h, HWND_TOPMOST)
      End If
      'Debug.Print "Top!"
    End If
  End If
  
End Sub


Sub SetWindowZOrder(hw As Long, insertAfter As Long)

  'Debug.Print "TopZ"
  
  Dim f As Long
  f = GetForegroundWindow()
  'Debug.Print getStrWindowTextAndClass(f), Hex(GetWindowLong(f, GWL_STYLE))
  'Debug.Print getStrWindowTextAndClass(hw), insertAfter
  
  Call SetWindowPos(hw, insertAfter, 0, 0, 0, 0, SWP_NOMOVE + SWP_NOSIZE + SWP_NOACTIVATE)

End Sub


Function IsDXWindow(h As Long) As Boolean

  Dim sc As String
  
  sc = getStrClass(h)
  
  IsDXWindow = False
  
  If Left$(sc, 4) = "#327" Then
    Exit Function
  End If
  
  Dim l As Long
  
  If InStr(sc, "DDWnd") > 0 Then
    IsDXWindow = True
    Exit Function
  End If
  
  l = GetWindowLong(h, GWL_STYLE)
  If (l And &HFFFF0000) = &H94080000 Or l = &H94000000 Then
    
    Dim r As RECT
    Call GetWindowRect(h, r)
    
    If r.Top = 0 And r.Left = 0 Then
      If r.bottom = GetScreenHeight() And r.Right = GetScreenWidth() Then
        'Debug.Print r.Top, r.Left, r.bottom, r.Right
        IsDXWindow = True
      End If
    End If
  End If


End Function


Function GetScreenWidth() As Long
  
  Dim dc As Long
  
  dc = GetDC(0)
  GetScreenWidth = GetDeviceCaps(dc, HORZRES)
  Call ReleaseDC(0, dc)

  'Debug.Print Now, "ScreenWidth: "; GetScreenWidth

End Function

Function GetScreenHeight() As Long
  
  Dim dc As Long
  
  dc = GetDC(0)
  GetScreenHeight = GetDeviceCaps(dc, VERTRES)
  Call ReleaseDC(0, dc)

End Function


Function IsPopupActive() As Boolean

  Dim h As Long
  
  IsPopupActive = False
  
  h = FindWindow("#32768", vbNullString)
  If h <> 0 Then
    If IsWindowVisible(h) Then
      IsPopupActive = True
    End If
  End If

End Function

Function IsSpecialWindow(h As Long) As Boolean

Dim wlng As Long, s As String

wlng = GetWindowLong(h, GWL_STYLE)

s = getStrClass(h)
  
IsSpecialWindow = (wlng And &HFFF00000) = WS_DXFULLSCREEN2 _
                  Or wlng = WS_DXFULLSCREEN2 _
                  Or s = "WindowsScreenSaverClass" _
                  Or InStr(LCase$(s), "tooltip") > 0 _
                  Or Left$(s, 4) = "#327" _
                  Or InStr(s, "DDWnd") > 0 _
                  Or IsWindowVisible(h) = 0

                  
                  'Or h = frmButtons.hWnd _
'IsSpecialWindow = True
'Debug.Print "IsSpecialWindow", getStrWindowTextAndClass(h), Hex(wlng), IsSpecialWindow

End Function


'bringt eine Form in die Mitte des Schrims oder der MDI-Form
Sub centerform(f As Form)
  
  f.Left = (Screen.Width / 2 - f.Width / 2) '/ tppx
  f.Top = (Screen.Height / 2 - f.Height / 2) '/ tppx

End Sub



Function getActiveConnection(ByRef h As Long) As String

  Dim lprasconn(255) As RASCONN, lpcConnections As Long, _
    lpcb As Long, hRasConn As Long, NameRasConn As String
  lprasconn(0).dwSize = 412
  lpcb = 256 * lprasconn(0).dwSize

  getActiveConnection = ""
  If RasEnumConnectionsA(lprasconn(0), lpcb, lpcConnections) = 0 Then
    If lpcConnections > 0 Then  ' Eine DF-Netzwerkverbindung ist aktiv
      hRasConn = lprasconn(0).hRasConn  ' Handle der Verbindung
      h = hRasConn
      NameRasConn = StrConv(lprasconn(0).szEntryName, vbUnicode)
      NameRasConn = Left$(NameRasConn, InStr(NameRasConn, vbNullChar) - 1)
      
      If InStr(NameRasConn, "Direct Cable Connection") > 0 Then
        Exit Function
      End If
      
      getActiveConnection = NameRasConn
    Else
      h = 0
    End If
  End If
  
  #If SimConnect = 1 Then
    getActiveConnection = "TESTTEST"
  #End If
  
End Function


Sub bringInRange(ByRef v As Variant, ByVal x As Variant, ByVal Y As Variant)

If v < x Then v = x
If v > Y Then v = Y

End Sub

Function ParseString$(ByRef CurPos As Long, ByVal Work As String, ByVal Delimit As String)


Dim s As String


If InStr(CurPos + 1, Work, Delimit) = 0 Then
  s = Mid$(Work, CurPos + 1)
  CurPos = Len(Work) + 1
Else
  s = Mid$(Work, CurPos + 1, InStr(CurPos + 1, Work, Delimit) - (CurPos + 1))
  CurPos = InStr(CurPos + 1, Work, Delimit)
End If




ParseString$ = Trim$(s)


End Function


Function MID2$(s As String, lngStart As Long, lngEnd As Long)

If (lngEnd - lngStart + 1) < 1 Then
  MID2$ = ""
Else
  MID2$ = Mid$(s, lngStart, lngEnd - lngStart + 1)
End If

End Function



Sub ReplaceString(strString As String, strOldChar As String, strNewChar As String)

  Dim lngN As Long
  
  lngN = InStr(strString, strOldChar)
  Do Until lngN = 0
    strString = Left$(strString, lngN - 1) & strNewChar & _
                Mid$(strString, lngN + Len(strOldChar), Len(strString))
    lngN = InStr(strString, strOldChar)
  Loop


End Sub







' ==========================================================================================================
Function getStrWindowTextAndClass(h As Long) As String

  If h = 0 Then
    getStrWindowTextAndClass = "NULL"
  Else
    getStrWindowTextAndClass = getStrWindowText(h) & ", " & getStrClass(h)
  End If

End Function

Function getStrClass(h As Long) As String
  
  Dim s As String
  Dim l As Long
  
  s = Space$(256)
  Call GetClassName(h, s, 256)
  
  getStrClass = nTrim$(s)
  
  #If debView = 1 Then
    Call OutDebStr(getStrClass)
  #End If

raus:

End Function




