//---------------------------------------------------------------------------

#include "stdafx.h"
#include "stdio.h"

#include "CNT4RASBytes.h"

//---------------------------------------------------------------------------


CNT4RASBytes::CNT4RASBytes()
{

  hQuery = NULL;
	hBytesR = hBytesT = 0;

	pdhStatus=PdhOpenQuery( NULL, 0, &hQuery );

	if( pdhStatus == ERROR_SUCCESS ) {
		pdhStatus = PdhAddCounter( hQuery, "\\RAS Total\\Bytes Received", 0, &hBytesR );
		pdhStatus = PdhAddCounter( hQuery, "\\RAS Total\\Bytes Transmitted", 0, &hBytesT );
	}

}

CNT4RASBytes::~CNT4RASBytes()
{
  PdhCloseQuery( &hQuery );
}


long CNT4RASBytes::GetRASBytes()
{
	pdhStatus=PdhCollectQueryData(hQuery);

	pdhStatus=PdhGetFormattedCounterValue(hBytesR,PDH_FMT_LONG,NULL,&sonuc);
	lBytesR = sonuc.longValue;

	pdhStatus=PdhGetFormattedCounterValue(hBytesT,PDH_FMT_LONG,NULL,&sonuc);
	lBytesT = sonuc.longValue;

	return ( lBytesR + lBytesT );
}

