Attribute VB_Name = "TraIconDeclares"
Option Explicit

Type NOTIFYICONDATA
  cbSize              As Long
  hwnd                As Long
  uID                 As Long
  uFlags              As Long
  uCallbackMessage    As Long
  hIcon               As Long
  szTip               As String * 64
End Type
    
Global nd As NOTIFYICONDATA
        
Public Const NIM_ADD = 0
Public Const NIM_MODIFY = 1
Public Const NIM_DELETE = 2
Public Const NIF_MESSAGE = 1
Public Const NIF_ICON = 2
Public Const NIF_TIP = 4

Public Const WM_LBUTTONDBLCLK = &H203
Public Const WM_LBUTTONDOWN = &H201
Public Const WM_LBUTTONUP = &H202
Public Const WM_RBUTTONDBLCLK = &H206
Public Const WM_RBUTTONDOWN = &H204
Public Const WM_RBUTTONUP = &H205
Public Const WM_MOUSEMOVE = &H200
Public Const WM_NULL = &H0

Declare Function Shell_NotifyIconA Lib "shell32" _
(ByVal dwMessage As Long, lpData As NOTIFYICONDATA) As Integer

Declare Function PostMessage Lib "user32" _
 Alias "PostMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, _
 ByVal wParam As Long, ByVal lParam As Long) As Long


Sub InstIcon(ic As Long, tt As String)

  Dim lRet As Long
  With nd
    .cbSize = Len(nd)
'    .hwnd = frmMain.picHook.hwnd
    .hwnd = frmMain.hwnd
    .uID = 1&
    .szTip = " " & tt & " " & Chr(0)
    .uCallbackMessage = WM_MOUSEMOVE
    .hIcon = ic
    .uFlags = NIF_MESSAGE Or NIF_ICON Or NIF_TIP
  End With
  lRet = Shell_NotifyIconA(NIM_ADD, nd)
  'Error check here
  'lRet = PostMessage(mnuPophwnd, WM_NULL, 0&, 0&) 'hrmf


End Sub

Public Sub TrayIconModify(ic As Long, Text As String)
    nd.uFlags = NIF_TIP + NIF_ICON
    nd.cbSize = Len(nd)
    nd.szTip = Left$(Text, 63) & Chr$(0)
    nd.hIcon = ic
    Call Shell_NotifyIconA(NIM_MODIFY, nd)
End Sub

Sub RemoveTrayIcon()
  Dim iRet As Integer
  With nd
    .cbSize = Len(nd)
'    .hwnd = frmMain.picHook.hwnd
    .hwnd = frmMain.hwnd
    .uID = 1&
  End With
  iRet = Shell_NotifyIconA(NIM_DELETE, nd)
End Sub
